/**
 *   Copyright (c) Rich Hickey. All rights reserved.
 *   The use and distribution terms for this software are covered by the
 *   Eclipse Public License 1.0 (http://opensource.org/licenses/eclipse-1.0.php)
 *   which can be found in the file epl-v10.html at the root of this distribution.
 *   By using this software in any fashion, you are agreeing to be bound by
 * 	 the terms of this license.
 *   You must not remove this notice, or any other, from this software.
 **/

/* rich Jun 19, 2006 */

package com.urbancode.commons.util.immutable;

final class ArraySeq<T> implements ISeq<T> {
    final T[] array;
    final int i;

    static public <T> ISeq<T> create(T[] array) {
        if (array == null || array.length == 0) {
            return null;
        }
        return new ArraySeq<T>(array, 0);
    }

    private ArraySeq(T[] array, int i) {
        this.array = array;
        this.i = i;
    }

    public T first() {
        return array[i];
    }

    public ISeq<T> next() {
        if (i + 1 < array.length) {
            return new ArraySeq<T>(array, i + 1);
        }
        return null;
    }
}
