/**
 * Copyright (c) Rich Hickey. All rights reserved.
 * The use and distribution terms for this software are covered by the
 * Eclipse Public License 1.0 (http://opensource.org/licenses/eclipse-1.0.php)
 * which can be found in the file epl-v10.html at the root of this distribution.
 * By using this software in any fashion, you are agreeing to be bound by
 * the terms of this license.
 * You must not remove this notice, or any other, from this software.
 */

package com.urbancode.commons.util.immutable;

import java.util.List;


public interface IImmutableList<T> extends IImmutableStack<T>, List<T> {
    IImmutableList<T> with(T o);
    T first();
    IImmutableList<T> rest();
    IImmutableList<T> pop();
    IImmutableList<T> subList(int fromIndex, int toIndex);
}
