/**
 *   Copyright (c) Rich Hickey. All rights reserved.
 *   The use and distribution terms for this software are covered by the
 *   Eclipse Public License 1.0 (http://opensource.org/licenses/eclipse-1.0.php)
 *   which can be found in the file epl-v10.html at the root of this distribution.
 *   By using this software in any fashion, you are agreeing to be bound by
 * 	 the terms of this license.
 *   You must not remove this notice, or any other, from this software.
 **/

/* rich Mar 3, 2008 */

package com.urbancode.commons.util.immutable;

import java.util.Collection;
import java.util.Set;

public interface IImmutableSet<T> extends Set<T>, IImmutableCollection<T> {
    IImmutableSet<T> with(T o);
    IImmutableSet<T> without(Object o);

    T get(T key);

    IImmutableSet<T> union(Collection<? extends T> coll);

    IImmutableSet<T> difference(Collection<?> coll);

    IImmutableSet<T> intersection(Collection<?> coll);
}
